$TYPECHECK ON
$APPTYPE GUI

'uncomment to be compatible with WINE, removes XP theme add-on stuff 
'$DEFINE __FREEQ_LEAN

CONST FREEQMAJORVERSION = 1
CONST FREEQMINORVERSION = 19
CONST FREEQVERSIONSTR AS STRING = "FreeQ IDEa (ver " + STR$(FREEQMAJORVERSION) + "." + STR$(FREEQMINORVERSION) + ")"

$INCLUDE <Windows.INC>                                  'include files in default directory 
$INCLUDE <Rapidq2.INC>                                  'can be found at http://rapidq.phatcode.net/include
'remove next line prior to final compile
'dim d as QDebug                                         'on the fly monitoring of variables, can causes a minor kernel error in some code

$INCLUDE <XP_Manifest.INC> 
$INCLUDE <QXPButton.INC>
$INCLUDE <qini.INC>
$INCLUDE <htmlHelp.INC>
$INCLUDE ".\inc_ide\decl.inc"
$INCLUDE ".\inc_ide\APIdecl.inc"
$INCLUDE <Scintilla\QScintilla.INC>                     '
         Scintilla_Initialize(True)                     'if sciLexer.dll is missing then close app

$INCLUDE ".\inc_ide\IDE_Resources.inc"                  'all global code here for starting app before splash screen
$INCLUDE ".\inc_ide\IDE_Globals.inc"                    'our global variables, data, structures
$INCLUDE ".\inc_ide\AppInstance.inc"                    'check if only on instance of FreeQ..
$INCLUDE <ShellRedir.INC>                               'for running compile thread
$INCLUDE ".\inc_ide\Splash.inc"                         'load up splash screen


'_________________________________________________________________________
    ini.Filename = TheMainIniFile
    IF (ini.Exist = False) Then 
        SplashForm.Show
        SHOWMESSAGE "Writing defaults to workspace" 
        IDE.New                                         'set defaults
        WriteIDEVariables(False)                        'write them but don't reset environment
    ELSE
        InstanceInit                                    'run single instance only?
        SplashFormInit                                  'will show depending on configuration
    END IF

'_________________________________________________________________________
IF IDE.ShowSplashScreen Then Gaugestart.Position = 10:  LabelStart.Caption = "Loading : Libraries"
$INCLUDE ".\inc_ide\IDE_gLibrary.inc"
'$INCLUDE ".\inc_ide\FileMonitor.inc"

'_________________________________________________________________________
IF IDE.ShowSplashScreen Then Gaugestart.Position = 20:  LabelStart.Caption = "Loading : Forms/Widgets"
$INCLUDE ".\inc_ide\MainForm.inc"
$INCLUDE ".\inc_ide\Menu.inc"
$INCLUDE ".\inc_ide\TopPanel.inc"
$INCLUDE ".\inc_ide\RightPanelObjects.inc"


'_________________________________________________________________________
IF IDE.ShowSplashScreen Then Gaugestart.Position = 30:  LabelStart.Caption = "Loading : Menus / config"
$INCLUDE ".\inc_ide\IDE_Dialogs.inc"
$INCLUDE ".\inc_ide\find_Replace.inc"
$INCLUDE ".\inc_ide\configuration.inc"
$INCLUDE ".\inc_ide\PopupMenus.inc"
$INCLUDE ".\inc_ide\PopupWindowsMenu.inc"
$INCLUDE ".\inc_ide\Menu_Subs.inc"          'after configuration.inc

'_________________________________________________________________________
'this one takes a long time under Windows 8
IF IDE.ShowSplashScreen Then Gaugestart.Position = 40:  LabelStart.Caption = "Loading :ini Start"
$INCLUDE ".\inc_ide\iniStart.inc"

'_________________________________________________________________________
IF IDE.ShowSplashScreen Then Gaugestart.Position = 45:  LabelStart.Caption = "Loading :App Wizard/ help"
$INCLUDE ".\inc_ide\IDE_AppWizard.inc"
$INCLUDE ".\inc_ide\Help.inc"

'_________________________________________________________________________
IF IDE.ShowSplashScreen Then Gaugestart.Position = 50:  LabelStart.Caption = "Loading : IDE routines"
$INCLUDE ".\inc_ide\MainForm_Subs.inc"
$INCLUDE ".\inc_ide\printer.inc"
$INCLUDE ".\inc_ide\ide_subs.inc"
$INCLUDE ".\inc_ide\ide_AutoComplete.inc"


'_________________________________________________________________________
IF IDE.ShowSplashScreen Then Gaugestart.Position = 60:  LabelStart.Caption = "Loading : Tools"
$INCLUDE ".\inc_ide\ProjectExplorer.inc"
$INCLUDE "tools\AutoDeclare.inc"
$INCLUDE "tools\File2Html.inc"
$INCLUDE "tools\rqPretty_plugin1_2.inc"
$INCLUDE "tools\ColorPicker.inc"
$INCLUDE "tools\KeyTool.inc"
$INCLUDE "tools\NumConverter.inc"

'_________________________________________________________________________
IF IDE.ShowSplashScreen Then Gaugestart.Position = 80:  LabelStart.Caption = "Setting visual styles"
$INCLUDE ".\inc_ide\XP_myButtons.inc"               'now aren't we pretty...
$INCLUDE ".\inc_ide\Menu_Pretty.inc"                'add icons to menu
Mnu_RightJustify                                    'right justify the last two menu items

'_________________________________________________________________________
IF IDE.ShowSplashScreen Then Gaugestart.Position = 85:  LabelStart.Caption = "Processing command line options"
$INCLUDE ".\inc_ide\CommandLineOp.inc"

 
'_________________________________________________________________________
IF IDE.ShowSplashScreen Then splashform.Close

'minimize to taskbar correctly doesn't work with QFormEx for some reason
SetWindowLong(Mainform.Handle, -8, 0)
SetWindowLong(APPLICATION.Handle, -8, Mainform.Handle)
Application.HintHidePause = 10000
Mainform.Showmodal