
$Resource Project_Ico as ".\_res\Project.ico"
$Resource Form_Ico as ".\_res\Form.ico"
$Resource Bitmap_Ico as ".\_res\Bitmap.ico"
$Resource Button_Ico as ".\_res\Button.ico"
$Resource Check_Ico as ".\_res\Check.ico"
$Resource Combo_Ico as ".\_res\Combo.ico"
$Resource CoolBtn_Ico as ".\_res\CoolBtn.ico"
$Resource Dialog_Ico as ".\_res\Dialog.ico"
$Resource Edit_Ico as ".\_res\Edit.ico"
$Resource Frame_Ico as ".\_res\Frame.ico"
$Resource Gauge_Ico as ".\_res\Gauge.ico"
$Resource Image_Ico as ".\_res\Image.ico"
$Resource Label_Ico as ".\_res\Label.ico"
$Resource List_Ico as ".\_res\List.ico"
$Resource ListView_Ico as ".\_res\ListView.ico"
$Resource MainMenu_Ico as ".\_res\MainMenu.ico"
$Resource MenuItem_Ico as ".\_res\MenuItem.ico"
$Resource Option_Ico as ".\_res\Option.ico"
$Resource Panel_Ico as ".\_res\Panel.ico"
$Resource RichEdit_Ico as ".\_res\RichEdit.ico"
$Resource ScrollBar_Ico as ".\_res\ScrollBar.ico"
$Resource Slide_Ico as ".\_res\Slide.ico"
$Resource Splitter_Ico as ".\_res\Splitter.ico"
$Resource StatusBar_Ico as ".\_res\StatusBar.ico"
$Resource StringGrid_Ico as ".\_res\StringGrid.ico"
$Resource Tab_Ico as ".\_res\Tab.ico"
$Resource TreeView_Ico as ".\_res\TreeView.ico"
$Resource Desconocido_Ico as ".\_res\Desconocido.ico"

Const TV_FIRST As Long = &H1100
Const TVM_SETITEMHEIGHT As Long = (TV_FIRST + 27)


Dim ImagenList as QImageList
    ImagenList.AddICOHandle Project_Ico
    ImagenList.AddICOHandle Form_Ico
    ImagenList.AddICOHandle Bitmap_Ico
    ImagenList.AddICOHandle Button_Ico
    ImagenList.AddICOHandle Check_Ico
    ImagenList.AddICOHandle Combo_Ico
    ImagenList.AddICOHandle CoolBtn_Ico
    ImagenList.AddICOHandle Dialog_Ico
    ImagenList.AddICOHandle Edit_Ico
    ImagenList.AddICOHandle Frame_Ico
    ImagenList.AddICOHandle Gauge_Ico
    ImagenList.AddICOHandle Image_Ico
    ImagenList.AddICOHandle Label_Ico
    ImagenList.AddICOHandle List_Ico
    ImagenList.AddICOHandle ListView_Ico
    ImagenList.AddICOHandle MainMenu_Ico
    ImagenList.AddICOHandle MenuItem_Ico
    ImagenList.AddICOHandle Option_Ico
    ImagenList.AddICOHandle Panel_Ico
    ImagenList.AddICOHandle RichEdit_Ico
    ImagenList.AddICOHandle ScrollBar_Ico
    ImagenList.AddICOHandle Slide_Ico
    ImagenList.AddICOHandle Splitter_Ico
    ImagenList.AddICOHandle StatusBar_Ico
    ImagenList.AddICOHandle StringGrid_Ico
    ImagenList.AddICOHandle Tab_Ico
    ImagenList.AddICOHandle TreeView_Ico
    ImagenList.AddICOHandle Desconocido_Ico

    Create ProjectTree as QTreeView
      parent = LeftPanelBottomPanel
      Align = AlClient
      ReadOnly = True
      Images = ImagenList
      Item(0).SelectedIndex = 0
      Indent = 10
      OnMouseDown = ProjectTree_MouseDown
      OnExpanding = ProjectTree_Expand
      OnCollapsing = ProjectTree_Collapse
      OnGetSelectedIndex = ProjectTree_OnGetSelectedIndex
      OnDblClick = ProjectTree_DblClick
      FullCollapse
    End Create


SendMessage(ProjectTree.Handle,TVM_SETITEMHEIGHT,25,0)


Sub ProjectTree_MouseDown(Button%,X%,Y%,Shift%)
  Dim a as long
  If Button% = 1 then
    a = ProjectTree.GetItemAt(X%,Y%) 
    ProjectTree.ItemIndex = a
  End If
  If Button% = 0 then
'    ClickAt = ProjectTree.GetItemAt(X%,Y%) 
  end if
End Sub

Sub ProjectTree_Expand (index%,AllowExpansion%)
'  If Index% = 0 then exit Sub
'  ProjectTree.Item(Index%).ImageIndex = 2
'  ProjectTree.Item(Index%).SelectedIndex = 2
End Sub

Sub ProjectTree_Collapse(index%)
'  If Index% = 0 then exit Sub
'  ProjectTree.Item(Index%).ImageIndex = 1
End Sub

Sub ProjectTree_OnGetSelectedIndex(Index%)
  If Index% = 0 then exit Sub
  ProjectTree.Item(Index%).SelectedIndex = ProjectTree.Item(Index%).ImageIndex
End Sub


sub ProjectTree_DblClick
'  ShowMessage str$(ClickAt)
end sub

Sub LoadProjectTree 'mnuFileOpen_Click
  ProjectTree.Clear
'  File.Open(OpenDlg.FileName,fmOpenRead)
  ProjectTree.AddItems "Project"
  tmpList.Text = re.Text
  inspector(tmpList)
  ProjectTree.FullCollapse
  ProjectTree.Expand 0,0
End Sub


sub Inspector (TheList AS QSTRINGLIST) ' Recursive Sub for populate TreeView
  Dim Position as integer
  Dim j as integer
  Dim Parent as integer
  Dim Line as string
  dim newline as string
  dim replaced as string
  dim nb as integer
  dim test as string
  Dim tmpLine as string

  STATIC i '= 0

  Parent = ProjectTree.ItemCount-1 '<--------------This the KEY for work
  WHILE (i < TheList.ItemCount -1) 'NOT File.EOF

    DoEvents

  Do
    
        Test = TRIM$(TheList.Item(i))    '<-------------------------get new line 
        Test = CleanComents(test)                   '<----------Clean Comentaries
        if Right$(Test,1) = "_" then Position = Len(Test) Else Position = 0  ' <---- test for line break
        While Position <> 0                        '<-----------if any then
            Test = LEFT$(Test, Position-1)            '<----------Clean it
            i++
            tmpLine = TRIM$( TheList.Item(i))       '<----------Read the next line 
            tmpLine = CleanComents(TmpLine)         '<----------Clean Comentaries
            test = test + tmpLine                   '<----------Concatena line
            if Right$(Test,1) = "_" then Position = Len(Test) else Position = 0 '<----test for new line break
        Wend
   Loop Until Len(Test) OR (i = ( TheList.ItemCount -1))

    ' Create Fields
    replaced= REPLACESUBSTR$(Line," ", "|")
    nb=TALLY(replaced,"|")
    NewLine = ""
    for j =1 to nb
      if len(field$(replaced,"|",j))>0 then newline = newline + field$(replaced,"|",j)+"|"
      if j=nb then newline=newline+field$(replaced,"|",nb+1)
    next

    ' Find for: END CREATE
    IF ucase$(field$(newline,"|",1))="END" AND ucase$(field$(newline,"|",2))="CREATE" THEN
      dec Parent
      Exit sub
    End IF

    'Find for: CREATE + AS + any <-- you can create one control with not "Q" in first character
    IF ucase$(field$(newline,"|",1))="CREATE" THEN
      IF ucase$(field$(newline,"|",3))="AS" THEN
        IF Len(field$(newline,"|",4)) <> 0 THEN 
          ProjectTree.AddChildItems Parent,field$(newline,"|",2)+ "   (" + ucase$(field$(newline,"|",4)) +")"
          AddIco ucase$(field$(newline,"|",4))
          ProjectTree.expand parent, 0
          Inspector(TheList)
        End IF
      End If
    End IF
  Wend
End Sub


' Function GetLine(Test AS STRING)as string ' Read one new line skip comentaries, blank lines and concatenate lines
'   dim test as string
'   Dim position as integer
'   Dim tmpLine as string
'   Do
' '    Test = File.ReadLine
'     Test = TRIM$(Test)        '<----------Clean Spaces
'     Test = CleanComents(test) '<----------Clean Comentaries
'     if Right$(Test,1) = "_" then Position = Len(Test) Else Position = 0  ' <---- test for line break
'     While Position <> 0                       '<-----------if any then
'       Test = LEFT$(Test,Position-1)           '<----------Clean it
' '      tmpLine = File.ReadLine                 '<----------Read the next line
'       tmpLine = TRIM$(tmpLine)                '<----------Clean Spaces
'       tmpLine = CleanComents(TmpLine)         '<----------Clean Comentaries
'       test = test + tmpLine                   '<----------Concatena line
'       if Right$(Test,1) = "_" then Position = Len(Test) else Position = 0 '<----test for new line break
'     Wend
'   Loop Until Len(Test) 'or File.EOF
'   result = test
' End Function


Function CleanComents(str as string)as string   'Delete all comments
  Dim Position as integer
  result = str            '<------------- Asume no coments in line
  Position=INSTR(str,"'") '<------------- search comment in the string
  IF Position >0 THEN result=RTRIM$(LEFT$(str,Position-1)) '<-----  If any, Clean it
End Function


Sub AddIco(Control as string)
  Select Case Control
    Case "QFORM"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 1
    Case "QBITMAP"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 2
    Case "QBUTTON"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 3
    CASE "QCHECKBOX"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 4
    CASE "QCOMBOBOX"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 5
    CASE "QCOOLBTN"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 6
    CASE "QOPENDIALOG", "QSAVEDIALOG"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 7
    CASE "QEDIT"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 8
    CASE "QGROUPBOX"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 9
    CASE "QGAUGE"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 10
    CASE "QIMAGE"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 11
    CASE "QLABEL"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 12
    CASE "QLISTBOX"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 13
    CASE "QLISTVIEW"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 14
    CASE "QMAINMENU"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 15
    CASE "QMENUITEM"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 16
    CASE "QRADIOBUTTON"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 17
    CASE "QPANEL"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 18
    CASE "QRICHEDIT"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 19
    CASE "QSCROLLBAR"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 20
    CASE "QSLIDE"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 21
    CASE "QSPLITTER"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 22
    CASE "QSTATUSBAR"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 23
    CASE "QSTRINGGRID"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 24
    CASE "QTABCONTROL"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 25
    CASE "QTREEVIEW"
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 26
    Case Else 
      ProjectTree.Item(ProjectTree.ItemCount-1).ImageIndex = 27
  End Select 
End Sub
  
